package com.example.as_trak;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;
import androidx.fragment.app.Fragment;

import android.os.Bundle;
import android.util.Log;

import com.example.as_trak.adapter.MyFragmentStateAdapter;
import com.example.as_trak.base.BaseActivity;
import com.example.as_trak.databinding.ActivityInfoBinding;
import com.example.as_trak.fragment.FlightInfoFragment;
import com.example.as_trak.fragment.LuggageFragment;
import com.google.android.material.tabs.TabLayoutMediator;

import java.util.ArrayList;
import java.util.List;

public class InfoActivity extends BaseActivity {
    private List<Fragment> fragments;
    private LuggageFragment luggageFragment;
    private  ActivityInfoBinding binding;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_info);
        fragments = new ArrayList<>();
        luggageFragment = new LuggageFragment();
        fragments.add(luggageFragment);
        fragments.add(new FlightInfoFragment());

        MyFragmentStateAdapter adapter = new MyFragmentStateAdapter(this);
        adapter.setFragments(fragments);
        binding.viewPager2.setAdapter(adapter);
        new TabLayoutMediator(binding.infoTabLayout, binding.viewPager2, (tab, position) -> {
            switch (position) {
                case 0:
                    tab.setText("行李信息");

                    break;
                case 1:
                    tab.setText("航班信息");

                    break;

            }
        }).attach();
        initScan();
    }

    @Override
    public void sanCodeResult(String code) {
        super.sanCodeResult(code);
        int currentItem = binding.viewPager2.getCurrentItem();
        if (currentItem==0){ //只有第一个页面的时候使用
            luggageFragment.sanCode(code);
        }

    }
}