package com.example.as_trak;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.view.View;

import androidx.databinding.DataBindingUtil;

import com.example.as_trak.adapter.ContainerTypesAdapter;
import com.example.as_trak.base.BaseActivity;
import com.example.as_trak.databinding.ActivitySettingBinding;
import com.example.as_trak.dialog.EditDialog;
import com.example.as_trak.entity.ContainerType;
import com.google.android.material.tabs.TabLayout;

import org.litepal.LitePal;

import java.util.ArrayList;
import java.util.List;

public class SettingActivity extends BaseActivity implements EditDialog.EditDialogCall, ContainerTypesAdapter.ContainerTypesAdapterCall {
    private EditDialog editDialog;
    private List<ContainerType> list;
    private ContainerTypesAdapter adapter;
    private String type;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivitySettingBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_setting);
        editDialog = new EditDialog(this);
        editDialog.setCall(this);
        adapter = new ContainerTypesAdapter(this, this);
        adapterSetList("1");
        binding.setAdapter(adapter);
        type="1";
        binding.infoTabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @SuppressLint("NotifyDataSetChanged")
            @Override
            public void onTabSelected(TabLayout.Tab tab) {

                String string = tab.getText().toString();
                if (string.equals("种类维护")) {
                    type = "1";
                }else if (string.equals("类型代码")){
                    type = "2";
                }else {
                    type = "3";
                }
                adapterSetList(type);

            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {

            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });


    }

    @SuppressLint("NotifyDataSetChanged")
    private void adapterSetList(String type) {
        list = LitePal.where("type = ?", type).find(ContainerType.class);
        if (list==null) {
            list=new ArrayList<>();
        }
        adapter.setList(list);
        adapter.notifyDataSetChanged();
    }

    @SuppressLint("NotifyDataSetChanged")
    @Override
    public void saveInfo(String info,String checkCode) {
        ContainerType containerType = new ContainerType();
        containerType.setTypeName(info);
        containerType.setCheckCode(checkCode);
        containerType.setType(type);
        containerType.save();
        list.add(containerType);
        adapter.notifyDataSetChanged();
        editDialog.dismiss();
    }

    @SuppressLint("NotifyDataSetChanged")
    @Override
    public void deleteCargoInfo(int index) {
        ContainerType containerType = list.get(index);
        containerType.delete();
        list.remove(index);
        adapter.notifyDataSetChanged();
    }
    public void settingAdd(View view){
        editDialog.setType(type);
        editDialog.show();
    }
}