package com.example.as_trak.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.as_trak.R;
import com.example.as_trak.databinding.ItemCargoBinding;
import com.example.as_trak.entity.CargoInfo;

import java.util.List;

public class CargoInfoAdapter extends RecyclerView.Adapter<CargoInfoAdapter.MyViewHolder> {
    private Context context;
    private LayoutInflater inflater;
    private List<CargoInfo> list;
    private CargoInfoCall call;

    public CargoInfoAdapter(Context context, CargoInfoCall call) {
        this.context = context;
        inflater = LayoutInflater.from(context);
        this.call = call;
    }

    public void setList(List<CargoInfo> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemCargoBinding binding = DataBindingUtil.inflate(inflater, R.layout.item_cargo, parent, false, null);
        return new MyViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        ItemCargoBinding binding = holder.binding;
        binding.setData(list.get(position));
        // binding.itemCargoD.setOnClickListener(v -> call.deleteCargoInfo(position));
        binding.itemCargoState.setOnClickListener(v -> call.updateState(position));
        binding.itemCargoC.setOnLongClickListener(v -> {
            call.longClickCargoInfo(position);
            return true;
        });
    }

    @Override
    public int getItemCount() {
        return list == null ? 0 : list.size();
    }


    static class MyViewHolder extends RecyclerView.ViewHolder {
        private ItemCargoBinding binding;

        public MyViewHolder(ItemCargoBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }

    public interface CargoInfoCall {
        void longClickCargoInfo(int index);
        void updateState(int index);

    }
}
