package com.example.as_trak.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.as_trak.R;
import com.example.as_trak.databinding.ItemCargoBinding;
import com.example.as_trak.databinding.ItemInfoAddBinding;
import com.example.as_trak.entity.CargoInfo;
import com.example.as_trak.entity.ContainerType;

import java.util.List;

public class ContainerTypesAdapter extends RecyclerView.Adapter<ContainerTypesAdapter.MyViewHolder> {
    private Context context;
    private LayoutInflater inflater;
    private List<ContainerType> list;
    private ContainerTypesAdapterCall call;
    public ContainerTypesAdapter(Context context, ContainerTypesAdapterCall call) {
        this.context = context;
        inflater=LayoutInflater.from(context);
        this.call=call;
    }

    public void setList(List<ContainerType> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemInfoAddBinding binding = DataBindingUtil.inflate(inflater, R.layout.item_info_add, parent, false, null);
        return new MyViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        ContainerType containerType = list.get(position);
        containerType.setTag(position+1);
        ItemInfoAddBinding binding = holder.binding;
        binding.setData(containerType);
        binding.itemCargoD.setOnClickListener(v -> call.deleteCargoInfo(position));

    }

    @Override
    public int getItemCount() {
        return list == null ? 0 : list.size();
    }


    static class MyViewHolder extends RecyclerView.ViewHolder {
        private ItemInfoAddBinding binding;

        public MyViewHolder(ItemInfoAddBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }

    public interface ContainerTypesAdapterCall {
        void deleteCargoInfo(int index);
    }
}
