package com.example.as_trak.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;

import androidx.databinding.DataBindingUtil;

import com.example.as_trak.R;
import com.example.as_trak.databinding.ItemFlightInfoBinding;
import com.example.as_trak.entity.FlightInfo;

import java.util.List;

public class FlightInfoAdapter extends BaseAdapter {
    private Context context;
    private List<FlightInfo> flightInfoList;
    public FlightInfoAdapter(Context context, List<FlightInfo> flightInfoList) {
        this.context = context;
        this.flightInfoList = flightInfoList;
    }
    @Override
    public int getCount() {
        return flightInfoList.size();
    }
    @Override
    public Object getItem(int position) {
        return flightInfoList.get(position);
    }
    @Override
    public long getItemId(int position) {
        return position;
    }
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ItemFlightInfoBinding binding;
        if (convertView == null) {
            binding = DataBindingUtil.inflate(
                    LayoutInflater.from(context),
                    R.layout.item_flight_info,
                    parent,
                    false
            );
            convertView = binding.getRoot();
            convertView.setTag(binding);
        } else {
            binding = (ItemFlightInfoBinding) convertView.getTag();
        }
        FlightInfo flightInfo = flightInfoList.get(position);
        binding.setFlightInfo(flightInfo);
        return convertView;
    }
}
