package com.example.as_trak.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.recyclerview.widget.RecyclerView;

import com.example.as_trak.R;
import com.example.as_trak.databinding.ItemLoadInfoBinding;
import com.example.as_trak.databinding.ItemOpinListBinding;
import com.example.as_trak.entity.LoadOperation;

import java.util.List;

public class LoadListAdapter extends RecyclerView.Adapter<LoadListAdapter.MyViewHolder> {
    private Context context;
    private LayoutInflater inflater;
    private List<LoadOperation> list;

    public LoadListAdapter(Context context) {
        this.context = context;
        inflater = LayoutInflater.from(context);
    }

    public void setList(List<LoadOperation> list) {
        this.list = list;
    }

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ItemOpinListBinding binding = DataBindingUtil.inflate(inflater, R.layout.item_opin_list, parent, false, null);
        return new MyViewHolder(binding);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        ItemOpinListBinding binding = holder.binding;
        LoadOperation data = list.get(position);
       /* if (data.getType().equals("拉下")){
            binding.itemOpinLinear.setBackgroundResource(R.drawable.button_delete);
        }else {
            binding.itemOpinLinear.setBackgroundResource(R.drawable.main_menu_bg);
        }*/

        // data.setOrderNum(position+1);
        binding.setData(data);

    }

    @Override
    public int getItemCount() {
        return list == null ? 0 : list.size();
    }


    static class MyViewHolder extends RecyclerView.ViewHolder {
        private ItemOpinListBinding binding;

        public MyViewHolder(ItemOpinListBinding binding) {
            super(binding.getRoot());
            this.binding = binding;
        }


    }

}
