package com.example.as_trak.dialog;


import android.app.Dialog;
import android.content.Context;
import android.os.Build;
import android.util.Log;
import android.view.LayoutInflater;
import android.widget.DatePicker;
import android.widget.TimePicker;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;

import com.example.as_trak.R;
import com.example.as_trak.databinding.DialogAddFlightBinding;

public class AddFlightDialog extends Dialog {
    private AddFlightDialogCall call;

    public void setCall(AddFlightDialogCall call) {
        this.call = call;
    }

    public AddFlightDialog(@NonNull Context context) {
        super(context, R.style.dialog_style);
        DialogAddFlightBinding binding = DataBindingUtil.inflate(LayoutInflater.from(context), R.layout.dialog_add_flight, null, false);
        setContentView(binding.getRoot());

        binding.returnDialogDis.setOnClickListener(v -> dismiss());
        TimePicker dialogTimepicker = binding.dialogTimepicker;
        dialogTimepicker.setIs24HourView(true);
        DatePicker dialogDatepicker = binding.dialogDatepicker;
        dialogDatepicker.setCalendarViewShown(false); // 隐藏日历视图
        dialogDatepicker.setSpinnersShown(true); // 显示数字选择器(true);

        binding.dialogReturnTrue.setOnClickListener(v -> {
            int month = dialogDatepicker.getMonth() + 1;
            String date = dialogDatepicker.getYear() + "-" + String.format("%02d", month) + "-" + dialogDatepicker.getDayOfMonth();
            // Log.e("TAG", "AddFlightDialog:" + date);
            String time= dialogTimepicker.getHour()+":"+dialogTimepicker.getMinute();
            String flightCode = binding.dialogFlightCode.getText().toString();
            String destination = binding.dialogFlightNum.getText().toString();
            if (flightCode.isEmpty()||destination.isEmpty()){
                return;
            }
            call.flightInfo(flightCode, destination, date, time);
        });
    }
    public interface AddFlightDialogCall{
        void flightInfo(String flightCode,String destination,String date,String time);
    }

}
