package com.example.as_trak.dialog;


import android.app.Dialog;
import android.content.Context;
import android.database.Observable;
import android.media.MediaPlayer;
import android.os.Vibrator;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.ViewGroup;
import android.view.Window;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.databinding.ObservableBoolean;
import androidx.databinding.ViewDataBinding;

import com.example.as_trak.R;
import com.example.as_trak.databinding.DialogTipBinding;

public class TipDialog extends Dialog {
    private MediaPlayer music;
    private MediaPlayer musicSuccess;
    private Vibrator vibrator;
    private ObservableBoolean state;
    private ObservableBoolean buttonVisState;
    private DialogTipBinding binding;

    public TipDialog(@NonNull Context context) {
        super(context, R.style.dialog_style);
        getWindow().setGravity(Gravity.BOTTOM);
        music = MediaPlayer.create(context, R.raw.error);
        musicSuccess = MediaPlayer.create(context, R.raw.success);
        vibrator = (Vibrator) context.getSystemService(Context.VIBRATOR_SERVICE);
        binding = DataBindingUtil.inflate(LayoutInflater.from(context), R.layout.dialog_tip, null, false);
        setContentView(binding.getRoot());
        state = new ObservableBoolean();
        setCanceledOnTouchOutside(false);
        binding.setState(state);
        buttonVisState=new ObservableBoolean();
        binding.setButtonVisState(buttonVisState);
        binding.tipDialogOver.setOnClickListener(v -> dismiss());
        binding.tipDialogAllwey.setOnClickListener(v -> tipCall.noAutoSub(code));

    }

    private String code;
    public void showError(String msg,String code,boolean buttonState) {
        super.show();
        music.start();
        vibrator.vibrate(500); // 震动1/2秒
        state.set(false);
        buttonVisState.set(buttonState);
        binding.toastMsg.setText(msg);
        this.code=code;
    }

    public void showSuccess(String msg) {
        super.show();
        musicSuccess.start();
        state.set(true);
        buttonVisState.set(false);
        binding.toastMsg.setText(msg);
    }

    public interface TipCall{
        void noAutoSub(String code);
    }
private TipCall tipCall;

    public void setTipCall(TipCall tipCall) {
        this.tipCall = tipCall;
    }
}
