package com.example.as_trak.dialog;

import android.app.Dialog;
import android.content.Context;
import android.view.LayoutInflater;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;

import com.example.as_trak.R;
import com.example.as_trak.databinding.DialogUpdateBinding;

public class UpdataDialog extends Dialog {
    private DialogUpdateBinding binding;
    private String code;
    private int index;
    private String tag;

    public void setTag(String tag) {
        this.tag = tag;
    }

    public void setIndex(int index) {
        this.index = index;
    }

    private UpdataDialogCall updataDialogCall;

    public void setUpdataDialogCall(UpdataDialogCall updataDialogCall) {
        this.updataDialogCall = updataDialogCall;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public UpdataDialog(@NonNull Context context) {
        super(context, R.style.dialog_style);
        binding = DataBindingUtil.inflate(LayoutInflater.from(context), R.layout.dialog_update, null, false);
        setContentView(binding.getRoot());
        binding.dialogDis.setOnClickListener(v -> dismiss());
        binding.dialogTrue.setOnClickListener(v -> {
            String code = binding.updataNewCode.getText().toString();
            if (code.isEmpty()) {
                return;
            }
            updataDialogCall.codeResult(tag, code, index);
        });
    }

    @Override
    public void show() {
        super.show();
        binding.setTag(tag);
        binding.updateOldCode.setText(code);
        binding.updataNewCode.setText(null);
    }
   public interface UpdataDialogCall{
        public void codeResult(String tag,String code,int index);
    }
}
