package com.example.as_trak.fragment;

import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.Toast;

import androidx.databinding.DataBindingUtil;
import androidx.fragment.app.Fragment;

import com.example.as_trak.R;
import com.example.as_trak.databinding.FragmentLuggageBinding;
import com.example.as_trak.entity.FlightInfo;
import com.example.as_trak.entity.LoadOperation;
import com.example.as_trak.fragment.been.LuggageBeen;

import org.litepal.LitePal;

import java.time.LocalTime;
import java.time.format.DateTimeFormatter;
import java.util.List;
import java.util.stream.IntStream;

public class LuggageFragment extends Fragment implements View.OnLongClickListener/*, SanCodeCall*/ {

    private LuggageBeen luggageBeen;
    private LoadOperation loadOperationFrist;
    private AlertDialog.Builder builder;
    private EditText loadMainFlightCode;

    @SuppressLint("ClickableViewAccessibility")
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        FragmentLuggageBinding binding = DataBindingUtil.inflate(inflater, R.layout.fragment_luggage, container, false);
        Bundle bundle = this.getArguments(); // 得到从Activity传来的数据
        String mess = null;
        luggageBeen = new LuggageBeen();
        if (bundle != null) {
            mess = bundle.getString("data");
            if (mess.equals("true")) {
                luggageBeen.setVisbleState(true);
            }
        }
        Context context = getContext();
        builder = new AlertDialog.Builder(context);
        builder.setTitle("拉下确认").setMessage("是否确定拉下行李").setNegativeButton("取消", null);
        binding.setData(luggageBeen);

        loadMainFlightCode = binding.loadMainFlightCode;
        loadMainFlightCode.setOnTouchListener((v, event) -> {
            final int DRAWABLE_RIGHT = 2;
            if (event.getAction() == MotionEvent.ACTION_UP) {
                // 获取触摸的位置
                int x = (int) event.getX();
                // 获取图标的边界
                int drawableRightWidth = loadMainFlightCode.getCompoundDrawables()[DRAWABLE_RIGHT].getBounds().width();
                int drawableRightStart = (int) (loadMainFlightCode.getWidth() - loadMainFlightCode.getPaddingRight() - drawableRightWidth);
                // 判断是否点击了右侧图标
                if (x >= drawableRightStart && x <= (loadMainFlightCode.getWidth() - loadMainFlightCode.getPaddingRight())) {
                    String code = loadMainFlightCode.getText().toString();
                    if (code.isEmpty()) return false;
                    selectInfo(code);
                    return true;
                }
            }
            return false;
        });
        binding.luggageUnLoad.setOnLongClickListener(this);

        return binding.getRoot();
    }


    // 点击查询
    private void selectInfo(String code) {
        loadOperationFrist = LitePal.where("luggageCode like ?  and (state IS NULL or state = '修改')", code + "%").order("loadTime desc").findFirst(LoadOperation.class);
        if (loadOperationFrist == null) {
            Toast.makeText(getContext(), "查询失败，条码错误", Toast.LENGTH_SHORT).show();
            luggageBeen.clear();
            return;
        }
        luggageBeen.setFlightCode(loadOperationFrist.getFlightCode());
        luggageBeen.setCargoCode(loadOperationFrist.getCargoCode());
        luggageBeen.setState(loadOperationFrist.getType());
        luggageBeen.setLoadTime(loadOperationFrist.getLoadTime());
        String luggageCode = loadOperationFrist.getLuggageCode();
        luggageBeen.setLuggageCode(luggageCode);
        List<LoadOperation> loadOperationList = LitePal.where("flightId = ? and cargoId = ? and (state IS NULL or state = '修改') ", String.valueOf(loadOperationFrist.getFlightId()), String.valueOf(loadOperationFrist.getCargoId())).order("id asc").find(LoadOperation.class);
        FlightInfo flightInfo = LitePal.where("id=?", String.valueOf(loadOperationFrist.getFlightId())).findFirst(FlightInfo.class);
        luggageBeen.setTakeoffDate(flightInfo.getTakeoffDate());
        IntStream.range(0, loadOperationList.size()).filter(i -> loadOperationList.get(i).getLuggageCode().equals(luggageCode)).findFirst().ifPresent(i -> luggageBeen.setOrderNum(String.valueOf(i + 1)));

    }

    // 长按按钮弹窗
    @Override
    public boolean onLongClick(View v) {
        if (loadOperationFrist == null || loadOperationFrist.getType().equals("拉下")) {
            return false;
        }
        builder.setPositiveButton("确定", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                loadOperationFrist.setType("拉下");
                loadOperationFrist.setUnLoadTime(LocalTime.now().format(DateTimeFormatter.ofPattern("HH:mm")));
                loadOperationFrist.update(loadOperationFrist.getId());
                Toast.makeText(getContext(), "拉下成功", Toast.LENGTH_SHORT).show();
                luggageBeen.setState("拉下");
            }
        }).show();
        return true;
    }


    // @Override
    public void sanCode(String code) {
        Log.e("TAG", "接收:" + code);
        loadMainFlightCode.setText(code);
        selectInfo(code);// 查询
    }
}